diff -Naur --exclude=CVS --exclude=configs linux/kernel/sched.c linux-openmosix/kernel/sched.c
--- linux/kernel/sched.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/kernel/sched.c	2004-02-05 10:51:30.000000000 +0100
@@ -37,6 +37,10 @@
 extern void tqueue_bh(void);
 extern void immediate_bh(void);
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 /*
  * scheduler variables
  */
@@ -92,7 +96,11 @@
 spinlock_t runqueue_lock __cacheline_aligned = SPIN_LOCK_UNLOCKED;  /* inner */
 rwlock_t tasklist_lock __cacheline_aligned = RW_LOCK_UNLOCKED;	/* outer */
 
+#ifdef CONFIG_MOSIX
+LIST_HEAD(runqueue_head);
+#else
 static LIST_HEAD(runqueue_head);
+#endif /* CONFIG_MOSIX */
 
 /*
  * We align per-CPU scheduling data on cacheline boundaries,
@@ -166,6 +174,16 @@
 		 * over..
 		 */
 		weight = p->counter;
+#ifdef CONFIG_MOSIX
+		/* give a generous advantage to processes in MOSIX context: */
+		/* (they do not hog the CPU anyway) */
+		if (p->mosix.dflags & DINSCHED)
+			weight += MOSIX_ASLEEP_PRIORITY;
+		if (p->mosix.dflags & DDEPUTY)
+			weight += MOSIX_DEPUTY_PRIORITY;
+		if (p->mosix.commpri)
+			weight += MOSIX_RESPOND_PRIORITY;
+#endif /* CONFIG_MOSIX */
 		if (!weight)
 			goto out;
 			
@@ -330,6 +348,9 @@
 {
 	list_add_tail(&p->run_list, &runqueue_head);
 	nr_running++;
+#ifdef CONFIG_MOSIX
+	run_on(p);
+#endif /* CONFIG_MOSIX */
 }
 
 static inline void move_last_runqueue(struct task_struct * p)
@@ -350,12 +371,35 @@
 {
 	unsigned long flags;
 	int success = 0;
+#ifdef CONFIG_MOSIX
+	struct task_struct *origp = p;
+#endif /* CONFIG_MOSIX */
 
 	/*
 	 * We want the common case fall through straight, thus the goto.
 	 */
 	spin_lock_irqsave(&runqueue_lock, flags);
+#ifdef CONFIG_MOSIX
+	p = NORMAL_CONTEXT(p);
+	write_lock(&p->mosix.state_lock);
+	if(origp != p)
+	{
+		if(p->mosix.bstate != TASK_SAME)
+			p->state = TASK_RUNNING;
+	}
+	else if(p->mosix.bstate == TASK_SAME)
+		p->state = TASK_RUNNING;
+	else
+	{
+		p->mosix.bstate = TASK_RUNNING;
+		success = 1;
+		write_unlock(&p->mosix.state_lock);
+		goto out;
+	}
+	write_unlock(&p->mosix.state_lock);
+#else
 	p->state = TASK_RUNNING;
+#endif /* CONFIG_MOSIX */
 	if (task_on_runqueue(p))
 		goto out;
 	add_to_runqueue(p);
@@ -372,6 +416,30 @@
 	return try_to_wake_up(p, 0);
 }
 
+#ifdef CONFIG_MOSIX
+/* wake up a process only if it is interested in MOSIX events */
+void
+wake_up_mosix(struct task_struct *p)
+{
+	unsigned long flags = 0;
+
+	spin_lock_irqsave(&runqueue_lock, flags);
+	if(mosix_wakeable(p))
+	{
+		write_lock(&p->mosix.state_lock);	/* not irq! */
+		if(p->mosix.bstate != TASK_SAME)
+			p->state = TASK_RUNNING;
+		write_unlock(&p->mosix.state_lock);
+		if (!task_on_runqueue(p))
+		{
+			add_to_runqueue(p);
+			reschedule_idle(p);
+		}
+	}
+	spin_unlock_irqrestore(&runqueue_lock, flags);
+}
+#endif /* CONFIG_MOSIX */
+
 static void process_timeout(unsigned long __data)
 {
 	struct task_struct * p = (struct task_struct *) __data;
@@ -444,6 +512,11 @@
 
 	init_timer(&timer);
 	timer.expires = expire;
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DINSCHED)
+		timer.data = (unsigned long)MOSIX_CONTEXT(current);
+	else
+#endif /* CONFIG_MOSIX */
 	timer.data = (unsigned long) current;
 	timer.function = process_timeout;
 
@@ -550,6 +623,13 @@
 	struct task_struct *prev, *next, *p;
 	struct list_head *tmp;
 	int this_cpu, c;
+#ifdef CONFIG_MOSIX
+	auto volatile int handle_interim =
+		(current->state & (TASK_INTERRUPTIBLE|TASK_STOPPED)) &&
+		!(current->mosix.dflags & DINSCHED);
+
+	restart:
+#endif /* CONFIG_MOSIX */
 
 
 	spin_lock_prefetch(&runqueue_lock);
@@ -581,8 +661,42 @@
 			move_last_runqueue(prev);
 		}
 
+#ifdef CONFIG_MOSIX
+	if(handle_interim && need_interim_while_asleep())
+	{
+		int prev_kernel_lock_depth, prev_mosix_lock_depth;
+
+		do_interim_first:
+		write_lock(&prev->mosix.state_lock);	/* not irq! */
+		prev->mosix.bstate = prev->state;
+		prev->state = TASK_RUNNING;
+		write_unlock(&prev->mosix.state_lock);
+		prev->mosix.dflags |= DINSCHED;
+		spin_unlock_irq(&runqueue_lock);
+		prev_kernel_lock_depth = prev->lock_depth;
+		prev_mosix_lock_depth = prev->mosix.lock_depth;
+		prev->lock_depth = -1;
+		prev->mosix.lock_depth = -1;
+		run_interim_while_asleep();
+		prev->lock_depth = prev_kernel_lock_depth;
+		prev->mosix.lock_depth = prev_mosix_lock_depth;
+		if(prev_kernel_lock_depth != -1 || prev_mosix_lock_depth != -1)
+			reacquire_kernel_lock(prev);
+		spin_lock_irq(&runqueue_lock);
+		write_lock(&prev->mosix.state_lock);
+		prev->state = prev->mosix.bstate;
+		prev->mosix.bstate = TASK_SAME;
+		write_unlock(&prev->mosix.state_lock);
+		prev->mosix.dflags &= ~DINSCHED;
+		spin_unlock_irq(&runqueue_lock);
+		goto restart;
+	}
+#endif /* CONFIG_MOSIX */
 	switch (prev->state) {
 		case TASK_INTERRUPTIBLE:
+#ifdef CONFIG_MOSIX
+			if (!(prev->mosix.dflags & (DREMOTE|DINSCHED)))
+#endif /* CONFIG_MOSIX */
 			if (signal_pending(prev)) {
 				prev->state = TASK_RUNNING;
 				break;
@@ -632,6 +746,14 @@
 	 */
 	sched_data->curr = next;
 	task_set_cpu(next, this_cpu);
+#ifdef CONFIG_MOSIX
+	if(prev != next)
+		active_cpus += (next->pid != 0) - (prev->pid != 0);
+#endif /* CONFIG_MOSIX */
+#ifdef CONFIG_MOSIX_DIAG
+	if(active_cpus < 0 || active_cpus > smp_num_cpus)
+		mosix_panic("active_cpus got out of range");
+#endif /* CONFIG_MOSIX_DIAG */
 	spin_unlock_irq(&runqueue_lock);
 
 	if (unlikely(prev == next)) {
@@ -694,8 +816,28 @@
 	 */
 	switch_to(prev, next, prev);
 	__schedule_tail(prev);
+#ifdef CONFIG_MOSIX
+	prev = current;	/* we still use it */
+#endif /* CONFIG_MOSIX */
 
 same_process:
+
+#ifdef CONFIG_MOSIX
+	if(handle_interim)
+	{
+		spin_lock_irq(&runqueue_lock);
+		if(need_interim_while_asleep())
+			goto do_interim_first;
+		spin_unlock_irq(&runqueue_lock);
+	}
+	if(prev->state != TASK_RUNNING)
+	{
+		reacquire_kernel_lock(prev);
+		mosix_panic("Sched-Race: MOSIX awakened too late.\n");
+		goto restart;
+	}
+#endif /* CONFIG_MOSIX */
+
 	reacquire_kernel_lock(current);
 	if (current->need_resched)
 		goto need_resched_back;
@@ -716,6 +858,9 @@
 {
 	struct list_head *tmp;
 	struct task_struct *p;
+#ifdef CONFIG_MOSIX
+	struct task_struct *realp;
+#endif /* CONFIG_MOSIX */
 
 	CHECK_MAGIC_WQHEAD(q);
 	WQ_CHECK_LIST_HEAD(&q->task_list);
@@ -726,7 +871,25 @@
 
 		CHECK_MAGIC(curr->__magic);
 		p = curr->task;
+#ifdef CONFIG_MOSIX
+		realp = NORMAL_CONTEXT(p);
+		if(realp != p)
+		{
+			read_lock(&realp->mosix.state_lock);
+			if(realp->mosix.bstate == TASK_SAME)
+			{
+				/* no longer in MOSIX */
+				read_unlock(&realp->mosix.state_lock);
+				continue;
+			}
+			state = realp->state;
+			read_unlock(&realp->mosix.state_lock);
+		}
+		else
+			state = LOGICAL_STATE(p);
+#else
 		state = p->state;
+#endif /* CONFIG_MOSIX */
 		if (state & mode) {
 			WQ_NOTE_WAKER(curr);
 			if (try_to_wake_up(p, sync) && (curr->flags&WQ_FLAG_EXCLUSIVE) && !--nr_exclusive)
@@ -785,6 +948,35 @@
 	spin_unlock_irq(&x->wait.lock);
 }
 
+#ifdef CONFIG_MOSIX
+void wait_for_completion_half_interruptible(struct completion *x)
+{
+	struct task_struct *p = current;
+
+	spin_lock_irq(&x->wait.lock);
+	if (!x->done) {
+		DECLARE_WAITQUEUE(wait, current);
+
+		wait.flags |= WQ_FLAG_EXCLUSIVE;
+		__add_wait_queue_tail(&x->wait, &wait);
+		do {
+			__set_current_state(TASK_INTERRUPTIBLE);
+			spin_unlock_irq(&x->wait.lock);
+			spin_lock_irq(&p->sigmask_lock);
+			p->mosix.ignoreoldsigs = 1;
+			p->sigpending = 0;
+			spin_unlock_irq(&p->sigmask_lock);
+			schedule();
+			spin_lock_irq(&x->wait.lock);
+		} while (!x->done);
+		__remove_wait_queue(&x->wait, &wait);
+	}
+	x->done--;
+	spin_unlock_irq(&x->wait.lock);
+	recalc_sigpending(p);
+}
+#endif /* CONFIG_MOSIX */
+
 #define	SLEEP_ON_VAR				\
 	unsigned long flags;			\
 	wait_queue_t wait;			\
@@ -920,6 +1112,10 @@
 	if (newprio > 19)
 		newprio = 19;
 	current->nice = newprio;
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+		mosix_inform_remote_of_nice();
+#endif /* CONFIG_MOSIX */
 	return 0;
 }
 
@@ -988,6 +1184,31 @@
 	    !capable(CAP_SYS_NICE))
 		goto out_unlock;
 
+#ifdef CONFIG_MOSIX
+	spin_unlock(&runqueue_lock);
+	if(policy != SCHED_OTHER)
+	{
+		while(p->mosix.dflags & DDEPUTY)
+		{
+			get_task_struct(p);
+			read_unlock_irq(&tasklist_lock);
+			if((retval = mosix_send_back_home(p)))
+				return(retval);
+			read_lock(&tasklist_lock);
+			free_task_struct(p);
+		}
+		task_lock(p);
+		p->mosix.stay |= DSTAY_FOR_RT;
+		task_unlock(p);
+	}
+	else
+	{
+		task_lock(p);
+		p->mosix.stay &= ~DSTAY_FOR_RT;
+		task_unlock(p);
+	}
+	spin_lock(&runqueue_lock);
+#endif /* CONFIG_MOSIX */
 	retval = 0;
 	p->policy = policy;
 	p->rt_priority = lp.sched_priority;
@@ -1348,6 +1569,10 @@
  	exit_files(current);
 	current->files = init_task.files;
 	atomic_inc(&current->files->count);
+#ifdef CONFIG_MOSIX_DFSA
+	atomic_inc(&current->files->users);
+	atomic_inc(&fs->users);
+#endif /* CONFIG_MOSIX_DFSA */
 }
 
 extern unsigned long wait_init_idle;
diff -Naur --exclude=CVS --exclude=configs linux/kernel/signal.c linux-openmosix/kernel/signal.c
--- linux/kernel/signal.c	2003-06-13 16:51:39.000000000 +0200
+++ linux-openmosix/kernel/signal.c	2004-02-05 10:51:30.000000000 +0100
@@ -14,6 +14,11 @@
 #include <linux/init.h>
 #include <linux/sched.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#include <linux/interrupt.h>
+#endif /* CONFIG_MOSIX */
+
 #include <asm/uaccess.h>
 
 /*
@@ -105,6 +110,9 @@
 void
 flush_signals(struct task_struct *t)
 {
+#ifdef CONFIG_MOSIX
+	if(!(t->mosix.dflags & DFAKESIGNAL))
+#endif /* CONFIG_MOSIX */
 	t->sigpending = 0;
 	flush_sigqueue(&t->pending);
 }
@@ -119,6 +127,9 @@
 		if (atomic_dec_and_test(&sig->count))
 			kmem_cache_free(sigact_cachep, sig);
 	}
+#ifdef CONFIG_MOSIX
+	if(!(tsk->mosix.dflags & DFAKESIGNAL))
+#endif /* CONFIG_MOSIX */
 	tsk->sigpending = 0;
 	flush_sigqueue(&tsk->pending);
 	spin_unlock_irq(&tsk->sigmask_lock);
@@ -275,6 +286,9 @@
 		if (current->notifier) {
 			if (sigismember(current->notifier_mask, sig)) {
 				if (!(current->notifier)(current->notifier_data)) {
+#ifdef CONFIG_MOSIX
+					if(!(current->mosix.dflags&DFAKESIGNAL))
+#endif /* CONFIG_MOSIX */
 					current->sigpending = 0;
 					return 0;
 				}
@@ -411,7 +425,11 @@
 	switch (sig) {
 	case SIGKILL: case SIGCONT:
 		/* Wake up the process if stopped.  */
+#ifdef CONFIG_MOSIX
+		if (LOGICAL_STATE(t) == TASK_STOPPED)
+#else
 		if (t->state == TASK_STOPPED)
+#endif /* CONFIG_MOSIX */
 			wake_up_process(t);
 		t->exit_code = 0;
 		rm_sig_from_queue(SIGSTOP, t);
@@ -494,6 +512,11 @@
  */
 static inline void signal_wake_up(struct task_struct *t)
 {
+#ifdef CONFIG_MOSIX
+	t->mosix.ignoreoldsigs = 0;
+	if(t->mosix.dflags & DHEAVYSLEEP)
+		return;
+#endif /* CONFIG_MOSIX */
 	t->sigpending = 1;
 
 #ifdef CONFIG_SMP
@@ -513,7 +536,11 @@
 	spin_unlock(&runqueue_lock);
 #endif /* CONFIG_SMP */
 
+#ifdef CONFIG_MOSIX
+	if (LOGICAL_STATE(t) & TASK_INTERRUPTIBLE) {
+#else
 	if (t->state & TASK_INTERRUPTIBLE) {
+#endif /* CONFIG_MOSIX */
 		wake_up_process(t);
 		return;
 	}
@@ -591,6 +618,42 @@
 {
 	unsigned long int flags;
 
+#ifdef CONFIG_MOSIX
+	if(t->mosix.dflags & DREMOTE)
+	{
+		int n;
+		siginfo_t *x;
+
+		if(!info || ((long)info) == 1)
+			panic("remote force_sig_info");
+		info->si_signo = sig;
+		/* (should be anyway, but some callers are mindless about it) */
+		if(in_interrupt())
+			panic("remote force_sig_info in interrupt");
+		repeat:
+		n = t->mosix.nforced_sigs;
+		if(!(x = kmalloc((n + 1) * sizeof(siginfo_t), GFP_KERNEL)))
+		{
+			/* just do our best */
+			send_sig(sig, t, 0);
+			return(0);
+		}
+		spin_lock_irqsave(&t->sigmask_lock, flags);
+		if(t->mosix.nforced_sigs != n)
+		{
+			spin_unlock_irqrestore(&t->sigmask_lock, flags);
+			kfree(x);
+			goto repeat;
+		}
+		if(n)
+			memcpy(x, t->mosix.forced_sigs, sizeof(siginfo_t) * n);
+		x[n] = *info;
+		t->mosix.forced_sigs = x;
+		t->mosix.nforced_sigs++;
+		spin_unlock_irqrestore(&t->sigmask_lock, flags);
+		return(0);
+	}
+#endif /* CONFIG_MOSIX */
 	spin_lock_irqsave(&t->sigmask_lock, flags);
 	if (t->sig == NULL) {
 		spin_unlock_irqrestore(&t->sigmask_lock, flags);
@@ -620,7 +683,11 @@
 
 		retval = -ESRCH;
 		read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+		for_each_local_task(p) {
+#else
 		for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 			if (p->pgrp == pgrp && thread_group_leader(p)) {
 				int err = send_sig_info(sig, info, p);
 				if (retval)
@@ -647,7 +714,11 @@
 
 		retval = -ESRCH;
 		read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+		for_each_local_task(p) {
+#else
 		for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 			if (p->leader && p->session == sess) {
 				int err = send_sig_info(sig, info, p);
 				if (retval)
@@ -698,7 +769,11 @@
 		struct task_struct * p;
 
 		read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+		for_each_local_task(p) {
+#else
 		for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 			if (p->pid > 1 && p != current && thread_group_leader(p)) {
 				int err = send_sig_info(sig, info, p);
 				++count;
@@ -722,12 +797,34 @@
 int
 send_sig(int sig, struct task_struct *p, int priv)
 {
+#ifdef CONFIG_MOSIX
+	if(p->mosix.dflags & DREMOTE)
+	{
+		unsigned long flags;
+
+		spin_lock_irqsave(&p->sigmask_lock, flags);
+		p->mosix.asig |= (1 << (sig-1));
+		spin_unlock_irqrestore(&p->sigmask_lock, flags);
+		if(p == current)
+			current->need_resched = 1;
+		return(0);
+	}
+#endif /* CONFIG_MOSIX */
 	return send_sig_info(sig, (void*)(long)(priv != 0), p);
 }
 
 void
 force_sig(int sig, struct task_struct *p)
 {
+#ifdef CONFIG_MOSIX
+	if(p->mosix.dflags & DREMOTE)
+	{
+		if(sig == SIGSEGV)
+			sig = FATAL_SIGSEGV;
+		send_sig(sig, p, 0);
+		return;
+	}
+#endif /* CONFIG_MOSIX */
 	force_sig_info(sig, (void*)1L, p);
 }
 
@@ -783,7 +880,11 @@
 
 	status = tsk->exit_code & 0x7f;
 	why = SI_KERNEL;	/* shouldn't happen */
+#ifdef CONFIG_MOSIX
+	switch (LOGICAL_STATE(tsk)) {
+#else
 	switch (tsk->state) {
+#endif /* CONFIG_MOSIX */
 	case TASK_STOPPED:
 		/* FIXME -- can we deduce CLD_TRAPPED or CLD_CONTINUED? */
 		if (tsk->ptrace & PT_PTRACED)
diff -Naur --exclude=CVS --exclude=configs linux/kernel/sys.c linux-openmosix/kernel/sys.c
--- linux/kernel/sys.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/kernel/sys.c	2004-02-05 10:51:30.000000000 +0100
@@ -37,6 +37,13 @@
 # define GET_FPEXC_CTL(a,b)	(-EINVAL)
 #endif
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 /*
  * this is where the system-wide overflow UID and GID are defined, for
  * architectures that now have 32-bit UID/GID but didn't in the past
@@ -193,6 +200,10 @@
 
 static int proc_sel(struct task_struct *p, int which, int who)
 {
+#ifdef CONFIG_MOSIX
+	if(p->mosix.dflags & DREMOTE)
+		return(0);
+#endif /* CONFIG_MOSIX */
 	if(p->pid)
 	{
 		switch (which) {
@@ -229,7 +240,11 @@
 		niceval = 19;
 
 	read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+	for_each_local_task(p) {
+#else
 	for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 		if (!proc_sel(p, which, who))
 			continue;
 		if (p->uid != current->euid &&
@@ -242,7 +257,18 @@
 		if (niceval < p->nice && !capable(CAP_SYS_NICE))
 			error = -EACCES;
 		else
+#ifdef CONFIG_MOSIX
+		{
+#endif /* CONFIG_MOSIX */
 			p->nice = niceval;
+#ifdef CONFIG_MOSIX
+			if(p->mosix.dflags & DDEPUTY)
+			{
+				tell_process(p, DREQ_NICECNG);
+				wake_up_mosix(p);
+			}
+		}
+#endif /* CONFIG_MOSIX */
 	}
 	read_unlock(&tasklist_lock);
 
@@ -419,7 +445,11 @@
 	}
 	if (new_egid != old_egid)
 	{
+#ifdef CONFIG_MOSIX
+		set_me_dumpable(0);
+#else
 		current->mm->dumpable = 0;
+#endif /* CONFIG_MOSIX */
 		wmb();
 	}
 	if (rgid != (gid_t) -1 ||
@@ -428,6 +458,12 @@
 	current->fsgid = new_egid;
 	current->egid = new_egid;
 	current->gid = new_rgid;
+#ifdef CONFIG_MOSIX
+	tell_process(current, DREQ_INFOCNG);
+#endif /* CONFIG_MOSIX */
+#ifdef CONFIG_MOSIX_DFSA
+	current->mosix.dupdates |= DFSA_UPDCRED;
+#endif /* CONFIG_MOSIX_DFSA */
 	return 0;
 }
 
@@ -440,11 +476,21 @@
 {
 	int old_egid = current->egid;
 
+#ifdef CONFIG_MOSIX
+	tell_process(current, DREQ_INFOCNG);
+#endif /* CONFIG_MOSIX */
+#ifdef CONFIG_MOSIX_DFSA
+	current->mosix.dupdates |= DFSA_UPDCRED;
+#endif /* CONFIG_MOSIX_DFSA */
 	if (capable(CAP_SETGID))
 	{
 		if(old_egid != gid)
 		{
+#ifdef CONFIG_MOSIX
+			set_me_dumpable(0);
+#else
 			current->mm->dumpable=0;
+#endif /* CONFIG_MOSIX */
 			wmb();
 		}
 		current->gid = current->egid = current->sgid = current->fsgid = gid;
@@ -453,7 +499,11 @@
 	{
 		if(old_egid != gid)
 		{
+#ifdef CONFIG_MOSIX
+			set_me_dumpable(0);
+#else
 			current->mm->dumpable=0;
+#endif /* CONFIG_MOSIX */
 			wmb();
 		}
 		current->egid = current->fsgid = gid;
@@ -520,10 +570,17 @@
 
 	if(dumpclear)
 	{
+#ifdef CONFIG_MOSIX
+		set_me_dumpable(0);
+#else
 		current->mm->dumpable = 0;
+#endif /* CONFIG_MOSIX */
 		wmb();
 	}
 	current->uid = new_ruid;
+#ifdef CONFIG_MOSIX
+	tell_process(current, DREQ_INFOCNG);
+#endif /* CONFIG_MOSIX */
 	return 0;
 }
 
@@ -558,6 +615,9 @@
 			return -EPERM;
 	}
 
+#ifdef CONFIG_MOSIX_DFSA
+	current->mosix.dupdates |= DFSA_UPDCRED;
+#endif /* CONFIG_MOSIX_DFSA */
 	if (euid != (uid_t) -1) {
 		new_euid = euid;
 		if ((old_ruid != euid) &&
@@ -572,7 +632,11 @@
 
 	if (new_euid != old_euid)
 	{
+#ifdef CONFIG_MOSIX
+		set_me_dumpable(0);
+#else
 		current->mm->dumpable=0;
+#endif /* CONFIG_MOSIX */
 		wmb();
 	}
 	current->fsuid = current->euid = new_euid;
@@ -606,6 +670,9 @@
 	int old_euid = current->euid;
 	int old_ruid, old_suid, new_ruid, new_suid;
 
+#ifdef CONFIG_MOSIX_DFSA
+	current->mosix.dupdates |= DFSA_UPDCRED;
+#endif /* CONFIG_MOSIX_DFSA */
 	old_ruid = new_ruid = current->uid;
 	old_suid = current->suid;
 	new_suid = old_suid;
@@ -619,7 +686,11 @@
 
 	if (old_euid != uid)
 	{
+#ifdef CONFIG_MOSIX
+		set_me_dumpable(0);
+#else
 		current->mm->dumpable = 0;
+#endif /* CONFIG_MOSIX */
 		wmb();
 	}
 	current->fsuid = current->euid = uid;
@@ -654,6 +725,9 @@
 		    (suid != current->euid) && (suid != current->suid))
 			return -EPERM;
 	}
+#ifdef CONFIG_MOSIX_DFSA
+	current->mosix.dupdates |= DFSA_UPDCRED;
+#endif /* CONFIG_MOSIX_DFSA */
 	if (ruid != (uid_t) -1) {
 		if (ruid != current->uid && set_user(ruid, euid != current->euid) < 0)
 			return -EAGAIN;
@@ -661,7 +735,11 @@
 	if (euid != (uid_t) -1) {
 		if (euid != current->euid)
 		{
+#ifdef CONFIG_MOSIX
+			set_me_dumpable(0);
+#else
 			current->mm->dumpable = 0;
+#endif /* CONFIG_MOSIX */
 			wmb();
 		}
 		current->euid = euid;
@@ -704,10 +782,17 @@
 		    (sgid != current->egid) && (sgid != current->sgid))
 			return -EPERM;
 	}
+#ifdef CONFIG_MOSIX_DFSA
+	current->mosix.dupdates |= DFSA_UPDCRED;
+#endif /* CONFIG_MOSIX_DFSA */
 	if (egid != (gid_t) -1) {
 		if (egid != current->egid)
 		{
+#ifdef CONFIG_MOSIX
+			set_me_dumpable(0);
+#else
 			current->mm->dumpable = 0;
+#endif /* CONFIG_MOSIX */
 			wmb();
 		}
 		current->egid = egid;
@@ -717,6 +802,9 @@
 		current->gid = rgid;
 	if (sgid != (gid_t) -1)
 		current->sgid = sgid;
+#ifdef CONFIG_MOSIX
+	tell_process(current, DREQ_INFOCNG);
+#endif /* CONFIG_MOSIX */
 	return 0;
 }
 
@@ -742,6 +830,9 @@
 {
 	int old_fsuid;
 
+#ifdef CONFIG_MOSIX_DFSA
+	current->mosix.dupdates |= DFSA_UPDCRED;
+#endif /* CONFIG_MOSIX_DFSA */
 	old_fsuid = current->fsuid;
 	if (uid == current->uid || uid == current->euid ||
 	    uid == current->suid || uid == current->fsuid || 
@@ -749,7 +840,11 @@
 	{
 		if (uid != old_fsuid)
 		{
+#ifdef CONFIG_MOSIX
+			set_me_dumpable(0);
+#else
 			current->mm->dumpable = 0;
+#endif /* CONFIG_MOSIX */
 			wmb();
 		}
 		current->fsuid = uid;
@@ -784,6 +879,9 @@
 {
 	int old_fsgid;
 
+#ifdef CONFIG_MOSIX_DFSA
+	current->mosix.dupdates |= DFSA_UPDCRED;
+#endif /* CONFIG_MOSIX_DFSA */
 	old_fsgid = current->fsgid;
 	if (gid == current->gid || gid == current->egid ||
 	    gid == current->sgid || gid == current->fsgid || 
@@ -791,7 +889,11 @@
 	{
 		if (gid != old_fsgid)
 		{
+#ifdef CONFIG_MOSIX
+			set_me_dumpable(0);
+#else
 			current->mm->dumpable = 0;
+#endif /* CONFIG_MOSIX */
 			wmb();
 		}
 		current->fsgid = gid;
@@ -807,6 +909,10 @@
 	 *	atomically safe type this is just fine. Conceptually its
 	 *	as if the syscall took an instant longer to occur.
 	 */
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+		mosix_deputy_rusage(0);
+#endif /* CONFIG_MOSIX */
 	if (tbuf)
 		if (copy_to_user(tbuf, &current->times, sizeof(struct tms)))
 			return -EFAULT;
@@ -862,7 +968,11 @@
 		goto out;
 	if (pgid != pid) {
 		struct task_struct * tmp;
+#ifdef CONFIG_MOSIX
+		for_each_local_task (tmp) {
+#else
 		for_each_task (tmp) {
+#endif /* CONFIG_MOSIX */
 			if (tmp->pgrp == pgid &&
 			    tmp->session == current->session)
 				goto ok_pgid;
@@ -876,6 +986,13 @@
 out:
 	/* All paths lead to here, thus we are safe. -DaveM */
 	read_unlock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+	if(!err)
+	{
+		tell_process(p, DREQ_INFOCNG);
+		wake_up_mosix(p);
+	}
+#endif /* CONFIG_MOSIX */
 	return err;
 }
 
@@ -929,7 +1046,11 @@
 	int err = -EPERM;
 
 	read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+	for_each_local_task(p) {
+#else
 	for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 		if (p->pgrp == current->pid)
 			goto out;
 	}
@@ -941,6 +1062,10 @@
 	err = current->pgrp;
 out:
 	read_unlock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+	if(err == current->pid)
+		tell_process(current, DREQ_INFOCNG);
+#endif /* CONFIG_MOSIX */
 	return err;
 }
 
@@ -979,6 +1104,9 @@
 		return -EPERM;
 	if ((unsigned) gidsetsize > NGROUPS)
 		return -EINVAL;
+#ifdef CONFIG_MOSIX_DFSA
+	current->mosix.dupdates |= DFSA_UPDCRED;
+#endif /* CONFIG_MOSIX_DFSA */
 	if(copy_from_user(current->groups, grouplist, gidsetsize * sizeof(gid_t)))
 		return -EFAULT;
 	current->ngroups = gidsetsize;
@@ -1146,6 +1274,22 @@
 			return -EPERM;
 	}
 	*old_rlim = new_rlim;
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+	switch(resource)
+	{
+		case RLIMIT_CPU:
+		case RLIMIT_DATA:
+		case RLIMIT_STACK:
+		case RLIMIT_RSS:
+		case RLIMIT_AS:
+#ifdef CONFIG_MOSIX_DFSA
+		case RLIMIT_NOFILE:
+		case RLIMIT_FSIZE:
+#endif /* CONFIG_MOSIX_DFSA */
+			mosix_deputy_rlimit(resource, new_rlim);
+	}
+#endif /* CONFIG_MOSIX */
 	return 0;
 }
 
@@ -1207,12 +1351,19 @@
 {
 	if (who != RUSAGE_SELF && who != RUSAGE_CHILDREN)
 		return -EINVAL;
+#ifdef CONFIG_MOSIX
+	if(who == RUSAGE_SELF && (current->mosix.dflags & DDEPUTY))
+		mosix_deputy_rusage(0);
+#endif /* CONFIG_MOSIX */
 	return getrusage(current, who, ru);
 }
 
 asmlinkage long sys_umask(int mask)
 {
 	mask = xchg(&current->fs->umask, mask & S_IRWXUGO);
+#ifdef CONFIG_MOSIX_DFSA
+	current->mosix.dupdates |= DFSA_UPDUMASK;
+#endif /* CONFIG_MOSIX_DFSA */
 	return mask;
 }
     
@@ -1235,7 +1386,11 @@
 			error = put_user(current->pdeath_signal, (int *)arg2);
 			break;
 		case PR_GET_DUMPABLE:
+#ifdef CONFIG_MOSIX
+			if (i_am_dumpable())
+#else
 			if (is_dumpable(current))
+#endif /* CONFIG_MOSIX */
 				error = 1;
 			break;
 		case PR_SET_DUMPABLE:
@@ -1243,7 +1398,13 @@
 				error = -EINVAL;
 				break;
 			}
-			current->mm->dumpable = arg2;
+#ifdef CONFIG_MOSIX
+			if (i_am_dumpable())
+				set_me_dumpable(arg2 != 0);
+#else
+			if (is_dumpable(current))
+				current->mm->dumpable = arg2;
+#endif /* CONFIG_MOSIX */
 			break;
 
 	        case PR_SET_UNALIGN:
diff -Naur --exclude=CVS --exclude=configs linux/kernel/sysctl.c linux-openmosix/kernel/sysctl.c
--- linux/kernel/sysctl.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/kernel/sysctl.c	2004-02-05 10:51:30.000000000 +0100
@@ -434,11 +434,23 @@
 		       ctl_table *table, void **context)
 {
 	int n;
+#ifdef CONFIG_MOSIX
+	/* single "get_user" calls are expensive: */
+	int udata[CTL_MAXNAME];
+	int *nextu = udata;
+
+	if(copy_from_user(udata, name, nlen * sizeof(int)))
+		return(-EFAULT);
+#endif /* CONFIG_MOSIX */
 repeat:
 	if (!nlen)
 		return -ENOTDIR;
+#ifdef CONFIG_MOSIX
+	n = *nextu++;
+#else
 	if (get_user(n, name))
 		return -EFAULT;
+#endif /* CONFIG_MOSIX */
 	for ( ; table->ctl_name; table++) {
 		if (n == table->ctl_name || table->ctl_name == CTL_ANY) {
 			int error;
@@ -869,10 +881,27 @@
 	
 	for (; left && vleft--; i++, first=0) {
 		if (write) {
+#ifdef CONFIG_MOSIX
+			/* "get_user" is expensive - need better optimization */
+			int nex = TMPBUFLEN;
+#endif /* CONFIG_MOSIX */
 			while (left) {
 				char c;
-				if (get_user(c, (char *) buffer))
+#ifdef CONFIG_MOSIX
+				if(nex == TMPBUFLEN)
+				{
+					len = left;
+					if(len > TMPBUFLEN)
+						len = TMPBUFLEN;
+					if(copy_from_user(buf, buffer, len))
+						return(-EFAULT);
+					nex = 0;
+				}
+				c = buf[nex++];
+#else
+				if (get_user(c,(char *) buffer))
 					return -EFAULT;
+#endif /* CONFIG_MOSIX */
 				if (!isspace(c))
 					break;
 				left--;
@@ -934,11 +963,29 @@
 		left--, buffer++;
 	}
 	if (write) {
+#ifdef CONFIG_MOSIX
+		/* "get_user" is expensive - need higher optimization */
+		int nex = TMPBUFLEN;
+#endif /* CONFIG_MOSIX */
 		p = (char *) buffer;
 		while (left) {
 			char c;
+#ifdef CONFIG_MOSIX
+			if(nex == TMPBUFLEN)
+			{
+				len = left;
+				if(len > TMPBUFLEN)
+					len = TMPBUFLEN;
+				if(copy_from_user(buf, p, len))
+					return(-EFAULT);
+				nex = 0;
+			}
+			c = buf[nex++];
+			p++;
+#else
 			if (get_user(c, p++))
 				return -EFAULT;
+#endif /* CONFIG_MOSIX */
 			if (!isspace(c))
 				break;
 			left--;
@@ -1022,10 +1069,27 @@
 	
 	for (; left && vleft--; i++, min++, max++, first=0) {
 		if (write) {
+#ifdef CONFIG_MOSIX
+			/* "get_user" is expensive - need higher optimization */
+			int nex = TMPBUFLEN;
+#endif /* CONFIG_MOSIX */
 			while (left) {
 				char c;
+#ifdef CONFIG_MOSIX
+				if(nex == TMPBUFLEN)
+				{
+					len = left;
+					if(len > TMPBUFLEN)
+						len = TMPBUFLEN;
+					if(copy_from_user(buf, buffer, len))
+						return(-EFAULT);
+					nex = 0;
+				}
+				c = buf[nex++];
+#else
 				if (get_user(c, (char *) buffer))
 					return -EFAULT;
+#endif /* CONFIG_MOSIX */
 				if (!isspace(c))
 					break;
 				left--;
@@ -1123,10 +1187,27 @@
 	
 	for (; left && vleft--; i++, first=0) {
 		if (write) {
+#ifdef CONFIG_MOSIX
+			/* "get_user" is expensive - need higher optimization */
+			int nex = TMPBUFLEN;
+#endif /* CONFIG_MOSIX */
 			while (left) {
 				char c;
+#ifdef CONFIG_MOSIX
+				if(nex == TMPBUFLEN)
+				{
+					len = left;
+					if(len > TMPBUFLEN)
+						len = TMPBUFLEN;
+					if(copy_from_user(buf, buffer, len))
+						return(-EFAULT);
+					nex = 0;
+				}
+				c = buf[nex++];
+#else
 				if (get_user(c, (char *) buffer))
 					return -EFAULT;
+#endif /* CONFIG_MOSIX */
 				if (!isspace(c))
 					break;
 				left--;
@@ -1185,11 +1266,29 @@
 		left--, buffer++;
 	}
 	if (write) {
+#ifdef CONFIG_MOSIX
+		/* "get_user" is expensive - need higher optimization */
+		int nex = TMPBUFLEN;
+#endif /* CONFIG_MOSIX */
 		p = (char *) buffer;
 		while (left) {
 			char c;
+#ifdef CONFIG_MOSIX
+			if(nex == TMPBUFLEN)
+			{
+				len = left;
+				if(len > TMPBUFLEN)
+					len = TMPBUFLEN;
+				if(copy_from_user(buf, p, len))
+					return(-EFAULT);
+				nex = 0;
+			}
+			c = buf[nex++];
+			p++;
+#else
 			if (get_user(c, p++))
 				return -EFAULT;
+#endif /* CONFIG_MOSIX */
 			if (!isspace(c))
 				break;
 			left--;
diff -Naur --exclude=CVS --exclude=configs linux/kernel/timer.c linux-openmosix/kernel/timer.c
--- linux/kernel/timer.c	2002-11-29 00:53:15.000000000 +0100
+++ linux-openmosix/kernel/timer.c	2004-02-05 10:51:30.000000000 +0100
@@ -25,6 +25,10 @@
 
 #include <asm/uaccess.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 /*
  * Timekeeping variables
  */
@@ -538,12 +542,26 @@
 	unsigned long user, unsigned long system)
 {
 	unsigned long psecs;
+#ifdef CONFIG_MOSIX
+	int i;
+#endif /* CONFIG_MOSIX */
 
 	psecs = (p->times.tms_utime += user);
 	psecs += (p->times.tms_stime += system);
+#ifdef CONFIG_MOSIX
+	if(p->mosix.dflags & DREMOTE)
+		psecs += p->mosix.passedtime;
+	if(!(p->mosix.dflags & DDEPUTY))
+#endif /* CONFIG_MOSIX */
 	if (psecs / HZ > p->rlim[RLIMIT_CPU].rlim_cur) {
 		/* Send SIGXCPU every second.. */
+#ifdef CONFIG_MOSIX
+		i = p->mosix.last_sigxcpu ? : p->rlim[RLIMIT_CPU].rlim_cur;
+		p->mosix.last_sigxcpu = psecs / HZ;
+		for(; i < p->mosix.last_sigxcpu ; i++)
+#else
 		if (!(psecs % HZ))
+#endif /* CONFIG_MOSIX */
 			send_sig(SIGXCPU, p, 1);
 		/* and SIGKILL when we go over max.. */
 		if (psecs / HZ > p->rlim[RLIMIT_CPU].rlim_max)
@@ -551,7 +569,11 @@
 	}
 }
 
+#ifdef CONFIG_MOSIX
+inline void do_it_virt(struct task_struct * p, unsigned long ticks)
+#else
 static inline void do_it_virt(struct task_struct * p, unsigned long ticks)
+#endif /* CONFIG_MOSIX */
 {
 	unsigned long it_virt = p->it_virt_value;
 
@@ -569,6 +591,11 @@
 {
 	unsigned long it_prof = p->it_prof_value;
 
+#ifdef CONFIG_MOSIX
+	if(p->mosix.dflags & DDEPUTY)
+		p->mosix.deputytime++;
+	else
+#endif /* CONFIG_MOSIX */
 	if (it_prof) {
 		if (--it_prof == 0) {
 			it_prof = p->it_prof_incr;
@@ -650,6 +677,9 @@
 	unsigned long active_tasks; /* fixed-point */
 	static int count = LOAD_FREQ;
 
+#ifdef CONFIG_MOSIX
+	mosix_snap_load(ticks);
+#endif /* CONFIG_MOSIX */
 	count -= ticks;
 	if (count < 0) {
 		count += LOAD_FREQ;
diff -Naur --exclude=CVS --exclude=configs linux/kernel/user.c linux-openmosix/kernel/user.c
--- linux/kernel/user.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/kernel/user.c	2004-02-05 10:51:30.000000000 +0100
@@ -87,6 +87,10 @@
 	struct user_struct **hashent = uidhashentry(uid);
 	struct user_struct *up;
 
+#ifdef CONFIG_MOSIX_DIAG
+	if(current->mosix.dflags & DREMOTE)
+		panic("REMOTE allocating uid");
+#endif /* CONFIG_MOSIX_DIAG */
 	spin_lock(&uidhash_lock);
 	up = uid_hash_find(uid, hashent);
 	spin_unlock(&uidhash_lock);
@@ -151,4 +155,46 @@
 	return 0;
 }
 
+#ifdef CONFIG_MOSIX
+
+extern int max_threads;
+
+struct user_struct remote_guests =
+{
+	__count:	ATOMIC_INIT(1),
+	processes:	ATOMIC_INIT(1),
+	files:		ATOMIC_INIT(0)
+};
+
+void
+init_guest_user_struct(void)
+{
+	struct task_struct *p = current;
+
+	free_uid(p->user);
+	p->user = &remote_guests;
+	p->rlim[RLIMIT_NPROC].rlim_cur = max_threads / 6;
+}
+
+int
+get_free_guest_slots(void)
+{
+	int a, b;
+
+	write_lock_irq(&tasklist_lock);
+	a = max_threads/6 - atomic_read(&remote_guests.__count);
+	b = max_threads - nr_threads;
+	write_unlock_irq(&tasklist_lock);
+	if(a < 0)	/* a little paranoidic */
+		a = 0;
+	return(a < b ? a : b);
+}
+
+int
+count_guests(void)
+{
+	return(atomic_read(&remote_guests.__count) - 1);
+}
+#endif /* CONFIG_MOSIX */
+
 module_init(uid_cache_init);
diff -Naur --exclude=CVS --exclude=configs linux/lib/rwsem.c linux-openmosix/lib/rwsem.c
--- linux/lib/rwsem.c	2001-07-11 05:08:51.000000000 +0200
+++ linux-openmosix/lib/rwsem.c	2004-02-05 10:51:31.000000000 +0100
@@ -122,6 +122,9 @@
 	/* set up my own style of waitqueue */
 	spin_lock(&sem->wait_lock);
 	waiter->task = tsk;
+#ifdef CONFIG_MOSIX
+	adjust_task_mosix_context(&waiter->task);
+#endif /* CONFIG_MOSIX */
 
 	list_add_tail(&waiter->list,&sem->wait_list);
 
diff -Naur --exclude=CVS --exclude=configs linux/lib/rwsem-spinlock.c linux-openmosix/lib/rwsem-spinlock.c
--- linux/lib/rwsem-spinlock.c	2002-11-29 00:53:15.000000000 +0100
+++ linux-openmosix/lib/rwsem-spinlock.c	2004-02-05 10:51:30.000000000 +0100
@@ -129,6 +129,9 @@
 
 	/* set up my own style of waitqueue */
 	waiter.task = tsk;
+#ifdef CONFIG_MOSIX
+	adjust_task_mosix_context(&waiter.task);
+#endif /* CONFIG_MOSIX */
 	waiter.flags = RWSEM_WAITING_FOR_READ;
 
 	list_add_tail(&waiter.list,&sem->wait_list);
@@ -197,6 +200,9 @@
 
 	/* set up my own style of waitqueue */
 	waiter.task = tsk;
+#ifdef CONFIG_MOSIX
+	adjust_task_mosix_context(&waiter.task);
+#endif /* CONFIG_MOSIX */
 	waiter.flags = RWSEM_WAITING_FOR_WRITE;
 
 	list_add_tail(&waiter.list,&sem->wait_list);
